#include "exo2.h"

Matrice Matrice_Create(int valeur)
{
	return NULL;
}

void Case_Free(Matrice *mat)
{
}

void Matrice_FreeLigne(Matrice *mat)
{
}

void Matrice_Free(Matrice *mat)
{
}

int Matrice_Ajouter_Ligne(Matrice *mat)
{
	return 1;
}

int Matrice_Ajouter_Colonne(Matrice *mat)
{
	return 1;
}

int Matrice_Lignes(Matrice mat)
{
	return 0;
}

int Matrice_Colonnes(Matrice mat)
{
	return 0;
}

Matrice Matrice_CreateBySize(int lignes, int colonnes)
{
	return NULL;
}

Matrice Matrice_CreateBySizeAndFunction(int lignes, int colonnes, int fonction(int ligne_i, int colonne_i))
{
	return NULL;
}

int identite(int ligne, int colonne)
{
	return 1;
}

int Matrice_Edit(Matrice mat, int ligne, int colonne, int new_valeur)
{
	return 1;
}

int Matrice_Supprimer_Ligne(Matrice *mat, int ligne)
{
	return 1;
}

int Matrice_Supprimer_Colonne(Matrice *mat, int colonne)
{
	return 1;
}

Matrice Matrice_GetCopie(Matrice mat)
{
	return NULL;
}

int Matrice_Trace(Matrice mat)
{
	return 0;
}

int Matrice_Additionner(Matrice *mat, Matrice ajout)
{
	return 1;
}

int Matrice_Multiplier(Matrice *mat, Matrice ajout)
{
	return 1;
}

int Matrice_Determinant(Matrice mat)
{
	return 0;
}

int Matrice_Transposer(Matrice *mat)
{
	return 1;
}

Matrice Matrice_GetComatrice(Matrice mat)
{
	return NULL;
}

void Matrice_Multiplier_ParScalaire(Matrice mat, int scalaire)
{
}

void Matrice_Diviser_ParScalaire(Matrice mat, int scalaire)
{
}

Matrice Matrice_GetInverse(Matrice mat)
{
	return NULL;
}

int pascal(int n, int k)
{
	return n|k;
}

int Matrice_Concatener_Ligne(Matrice *mat, Matrice *ajout)
{
	return 1;
}

int Matrice_Concatener_Colonne(Matrice *mat, Matrice *ajout)
{
	return 1;
}

int Matrice_EstEgal(Matrice mat, Matrice autre)
{
	return 1;
}

int Matrice_Symetrique(Matrice mat)
{
	return 1;
}

int Matrice_Antisymetrique(Matrice mat)
{
	return 1;
}

Matrice Matrice_Code(Matrice mat, Matrice cle)
{
	Matrice res = Matrice_GetCopie(mat);
	Matrice inv = Matrice_GetInverse(cle);
	Matrice_Multiplier(&res, cle);
	Matrice_Transposer(&res);
	Matrice_Multiplier(&res, inv);
	Matrice_Additionner(&res, cle);
	Matrice_Multiplier_ParScalaire(inv, -1);
	Matrice_Additionner(&res, inv);
	Matrice_Multiplier_ParScalaire(inv, -1);
	Matrice_Multiplier(&res, inv);
	return res;
}

Matrice Matrice_Decode(Matrice mat, Matrice cle)
{
	return NULL;
}

void Matrice_AfficherImage(Matrice mat)
{
	if(mat == NULL)
	{
		printf("?\n");
	}
	else
	{
		Matrice ligne = NULL;
		while(mat != NULL)
		{
			ligne = mat;
			while(ligne != NULL)
			{
				int val = ligne->valeur;
				while(val < 0)
					val += 8;
				printf("\033[4%dm  \033[0m", val%8);
				ligne = ligne->nextColonne;
			}
			printf("\n");
			mat = mat->nextLigne;
		}
	}
}

void Matrice_Afficher(Matrice mat)
{
	if(mat == NULL)
	{
		printf("?\n");
	}
	else
	{
		Matrice ligne = NULL;
		char format[5];
		sprintf(format, "%%%dd", Matrice_MaxTailleCase(mat));
		while(mat != NULL)
		{
			ligne = mat;
			fprintf(stderr, "|");
			while(ligne != NULL)
			{
				fprintf(stderr, format, ligne->valeur);
				ligne = ligne->nextColonne;
				if(ligne != NULL)
					fprintf(stderr, " ");
			}
			fprintf(stderr, "|\n");
			mat = mat->nextLigne;
		}
	}
}

int Matrice_MaxTailleCase(Matrice mat)
{
	int maxi = 0;
	int mini = 0;
	Matrice cur = NULL;
	while(mat != NULL)
	{
		cur = mat;
		while(cur != NULL)
		{
			if(cur->valeur > maxi)
				maxi = cur->valeur;
			if(cur->valeur < mini)
				mini = cur->valeur;
			cur = cur->nextLigne;
		}
		mat = mat->nextColonne;
	}
	char chaine_max[10], chaine_min[10];
	sprintf(chaine_max, "%d", maxi);
	sprintf(chaine_min, "%d", mini);
	return max(strlen(chaine_max), strlen(chaine_min));
}

Matrice Matrice_CreateByArgs(int lignes, int colonnes, ...)
{
	Matrice res = NULL;
	if((res = Matrice_CreateBySize(lignes, colonnes)) == NULL)
		return NULL;
	va_list ap;
	va_start(ap, colonnes);
	Matrice cur_l = res;
	Matrice cur_c = NULL;
	while(cur_l != NULL)
	{
		cur_c = cur_l;
		while(cur_c != NULL)
		{
			cur_c->valeur = va_arg(ap, int);
			cur_c = cur_c->nextColonne;
		}
		cur_l = cur_l->nextLigne;
	}
	va_end(ap);
	return res;
}
