#include "test.h"

void titre(const char *title, const char *format, ...)
{
	va_list args;
	va_start(args, format);
	char *chaine = NULL;
	if((chaine = (char*)malloc((strlen(format)+strlen("\033[33m\033[1m: \033[0m")+strlen(title)+1)*sizeof(char))) != NULL)
	{
		strcpy(chaine, "\033[33m\033[1m");
		strcat(chaine, title);
		strcat(chaine, ": ");
		strcat(chaine, format);
		strcat(chaine, "\033[0m");
		vprintf(chaine, args);
		free(chaine);
	}
	va_end(args);
}

int test(int condi, const char *nom_test, const char *format_erreur, ...)
{
	va_list args;
	va_start(args, format_erreur);
	char *chaine = NULL;
	if(condi)
	{
		if((chaine = (char*)malloc((strlen(nom_test)+strlen("\033[32m\033[1m: Validé\n\033[0m")+1)*sizeof(char))) == NULL)
			return 0;
		strcpy(chaine, "\033[32m\033[1m");
		strcat(chaine, nom_test);
		strcat(chaine, ": Validé\n\033[0m");
	}
	else
	{
		if((chaine = (char*)malloc((strlen(nom_test)+strlen(format_erreur)+strlen("\033[31m\033[1m: Echec:\n---\033[0m")+1)*sizeof(char))) == NULL)
			return 0;
		strcpy(chaine, "\033[31m\033[1m");
		strcat(chaine, nom_test);
		strcat(chaine, ": Echec:\n---");
		strcat(chaine, format_erreur);
		strcat(chaine, "\033[0m");
	}
	vprintf(chaine, args);
	free(chaine);
	va_end(args);
	return condi;
}

int test_only_error(int condi, const char *nom_test, const char *format_erreur, ...)
{
	if(!condi)
	{
		va_list args;
		va_start(args, format_erreur);
		char *chaine = NULL;
		if((chaine = (char*)malloc((strlen(nom_test)+strlen(format_erreur)+strlen("\033[31m\033[1m: Echec:\n---\033[0m")+1)*sizeof(char))) == NULL)
			return 0;
		strcpy(chaine, "\033[31m\033[1m");
		strcat(chaine, nom_test);
		strcat(chaine, ": Echec:\n---");
		strcat(chaine, format_erreur);
		strcat(chaine, "\033[0m");
		vprintf(chaine, args);
		free(chaine);
		va_end(args);
	}
	return condi;
}
